

NONE=0
ALL=1
LOCAL=2

yes=1
no=0
without_password=2
ignore=-1

FAKE = {}

def indirect(name, func, type, args):
    if type == 1:
        key = (name, args[0])
    else:
        key = name
    FAKE[key] = (func, args)

def commit_changes():
    for f in FAKE.values():
        if len(f[1]) >= 1 and f[1][0] != -1:
            apply(f[0], f[1])
        elif len(f[1]) == 0:
            apply(f[0])
                        
def print_changes():
    import sys
    for f in FAKE.values():
        l = len(f[1])
        if l >= 1 and f[1][0] != -1:
            name = f[0].__name__
            try:
                if f[0].one_arg:
                    l = 1
            except AttributeError:
                pass
            if l == 1:
                print name, get_translation(f[0], f[1][0])
            else:
                sys.stdout.write(name)
                for a in f[1]:
                    sys.stdout.write(' ' + str(a))
                sys.stdout.write('\n')

def get_translation(func, value):
    try:
        return func.arg_trans[value]
    except (KeyError, AttributeError):
        return value
    
import libmsec


def accept_bogus_error_responses(*args):
    indirect("accept_bogus_error_responses", libmsec.accept_bogus_error_responses, 0, args)
    

def accept_broadcasted_icmp_echo(*args):
    indirect("accept_broadcasted_icmp_echo", libmsec.accept_broadcasted_icmp_echo, 0, args)
    

def accept_icmp_echo(*args):
    indirect("accept_icmp_echo", libmsec.accept_icmp_echo, 0, args)
    

def allow_autologin(*args):
    indirect("allow_autologin", libmsec.allow_autologin, 0, args)
    

def allow_issues(*args):
    indirect("allow_issues", libmsec.allow_issues, 0, args)
    

def allow_reboot(*args):
    indirect("allow_reboot", libmsec.allow_reboot, 0, args)
    

def allow_remote_root_login(*args):
    indirect("allow_remote_root_login", libmsec.allow_remote_root_login, 0, args)
    

def allow_root_login(*args):
    indirect("allow_root_login", libmsec.allow_root_login, 0, args)
    

def allow_user_list(*args):
    indirect("allow_user_list", libmsec.allow_user_list, 0, args)
    

def allow_x_connections(*args):
    indirect("allow_x_connections", libmsec.allow_x_connections, 0, args)
    

def allow_xserver_to_listen(*args):
    indirect("allow_xserver_to_listen", libmsec.allow_xserver_to_listen, 0, args)
    

def authorize_services(*args):
    indirect("authorize_services", libmsec.authorize_services, 0, args)
    

changing_level=libmsec.changing_level


def closelog(*args):
    indirect("closelog", libmsec.closelog, 0, args)
    

def create_server_link(*args):
    indirect("create_server_link", libmsec.create_server_link, 0, args)
    

def enable_at_crontab(*args):
    indirect("enable_at_crontab", libmsec.enable_at_crontab, 0, args)
    

def enable_console_log(*args):
    indirect("enable_console_log", libmsec.enable_console_log, 0, args)
    

def enable_dns_spoofing_protection(*args):
    indirect("enable_dns_spoofing_protection", libmsec.enable_dns_spoofing_protection, 0, args)
    

def enable_ip_spoofing_protection(*args):
    indirect("enable_ip_spoofing_protection", libmsec.enable_ip_spoofing_protection, 0, args)
    

def enable_libsafe(*args):
    indirect("enable_libsafe", libmsec.enable_libsafe, 0, args)
    

def enable_log_strange_packets(*args):
    indirect("enable_log_strange_packets", libmsec.enable_log_strange_packets, 0, args)
    

def enable_msec_cron(*args):
    indirect("enable_msec_cron", libmsec.enable_msec_cron, 0, args)
    

def enable_pam_wheel_for_su(*args):
    indirect("enable_pam_wheel_for_su", libmsec.enable_pam_wheel_for_su, 0, args)
    

def enable_password(*args):
    indirect("enable_password", libmsec.enable_password, 0, args)
    

def enable_promisc_check(*args):
    indirect("enable_promisc_check", libmsec.enable_promisc_check, 0, args)
    

def enable_security_check(*args):
    indirect("enable_security_check", libmsec.enable_security_check, 0, args)
    

def enable_sulogin(*args):
    indirect("enable_sulogin", libmsec.enable_sulogin, 0, args)
    

def error(*args):
    indirect("error", libmsec.error, 0, args)
    

def get_index(*args):
    indirect("get_index", libmsec.get_index, 0, args)
    

get_secure_level=libmsec.get_secure_level


get_server_level=libmsec.get_server_level


def initlog(*args):
    indirect("initlog", libmsec.initlog, 0, args)
    

def log(*args):
    indirect("log", libmsec.log, 0, args)
    

no_password_aging_for=libmsec.no_password_aging_for


nopassword_loader=libmsec.nopassword_loader


def password_aging(*args):
    indirect("password_aging", libmsec.password_aging, 0, args)
    

def password_history(*args):
    indirect("password_history", libmsec.password_history, 0, args)
    

def password_length(*args):
    indirect("password_length", libmsec.password_length, 0, args)
    

password_loader=libmsec.password_loader


set_interactive=libmsec.set_interactive


def set_root_umask(*args):
    indirect("set_root_umask", libmsec.set_root_umask, 0, args)
    

def set_secure_level(*args):
    indirect("set_secure_level", libmsec.set_secure_level, 0, args)
    

def set_security_conf(*args):
    indirect("set_security_conf", libmsec.set_security_conf, 1, args)
    

def set_server_level(*args):
    indirect("set_server_level", libmsec.set_server_level, 0, args)
    

def set_shell_history_size(*args):
    indirect("set_shell_history_size", libmsec.set_shell_history_size, 0, args)
    

def set_shell_timeout(*args):
    indirect("set_shell_timeout", libmsec.set_shell_timeout, 0, args)
    

set_umask=libmsec.set_umask


def set_user_umask(*args):
    indirect("set_user_umask", libmsec.set_user_umask, 0, args)
    

set_zero_one_variable=libmsec.set_zero_one_variable

